/**
***     suspendapp.hpp
***
***     Copyright (C) 2008 SophiaCradle Incorporated.
***     All rights reserved.
***
***     ̃\[XR[h̓G[XgbvATXyhȂǂ̏Ă܂B
***     ۂ̎gpɍۂẮAKvɉďǉĂB
***
**/

#ifndef __SUSPENDAPP_HPP
#define __SUSPENDAPP_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFRESPONDER(WebFrame)
SFMTYPEDEFCLASS(suspendapp)
class suspendapp : public SFYApplication {
    SFMSEALCOPY(suspendapp)
    private:
        SFZTitleFlatFrameSmp            _frame;
        SFZWindowSmp                    _window;
        SFZSingleTextLabelControlSmp    _label;
        WebFrameSmp                     _webFrame1;
        WebFrameSmp                     _webFrame2;
    public:
        static SFCInvokerPtr Factory(Void);
        static Void Render(Void);
    private:
        explicit suspendapp(Void) static_throws;
        virtual ~suspendapp(Void);
        XANDLER_DECLARE_BOOLEVENT(OnKey)
};

class WebFrame : public SFZTitleFlatFrame {
    SFMSEALRESPONDER(WebFrame)
    SFMRESPONDERINSTANTIATEFOUR(WebFrame, SFZTitleFlatFrame, SFYFrame, SFYWidget, SFYResponder)
    private:
        SFZWindowSmp _window;
        SFZMultipleTextLabelControlSmp _label;
        SFXWideString _message;
        SFXAnsiString _url;
        SFBWebSmp _web;
        SFBWebRespSmp _webresp;
        SFBGetLineSmp _getline;
        SFXCallback _callback;

    public:
                WebFrame(Void);
        virtual ~WebFrame(Void);
        static  WebFrameSmp NewInstance(SFCErrorPtr exception = null);
        Void Create(SFXWideString string);
        Void Start(Void);

        XANDLER_DECLARE_BOOLEVENT(OnKey)
        XANDLER_DECLARE_VOIDRESUME(OnResume)
        XANDLER_DECLARE_VOIDSUSPEND(OnSuspend)
    private:
        XALLBACK_DECLARE_SFXCALLBACK(GotResp)
        Void Header(ACharConstPtr name, GetLine* val);
        Void Status(WebStatus status, VoidPtr val);
        XALLBACK_DECLARE_SFXCALLBACK(ReadLines)
        Void Stop(Void);
        Void Draw(Void);

        static Void HeaderSHP(WebFrame* p, ACharConstPtr name, GetLine* val)
        {
            p->Header(name, val);
            return;
        }
        static Void StatusSHP(WebFrame* p, WebStatus status, VoidPtr val)
        {
            p->Status(status, val);
            return;
        }
};

#endif // __SUSPENDAPP_HPP //
